## slicer 3.6.3~svn16592

=== CMakeLists.txt ===
PROJECT(Slicer3)

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
  CMAKE_POLICY(SET CMP0012 NEW)
ENDIF(COMMAND CMAKE_POLICY)
MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY)


#-----------------------------------------------------------------------------
#
set(Slicer3_INSTALL_BIN_DIR "bin")
set(Slicer3_INSTALL_LIB_DIR "lib/Slicer3")
set(Slicer3_INSTALL_INCLUDE_DIR "include/Slicer3")
set(Slicer3_INSTALL_SHARE_DIR "share/Slicer3")
set(Slicer3_INSTALL_ITKFACTORIES_DIR "${Slicer3_INSTALL_LIB_DIR}/ITKFactories")

set(Slicer3_INSTALL_PLUGINS_BIN_DIR "${Slicer3_INSTALL_LIB_DIR}/Plugins")
set(Slicer3_INSTALL_PLUGINS_LIB_DIR "${Slicer3_INSTALL_LIB_DIR}/Plugins")
set(Slicer3_INSTALL_PLUGINS_INCLUDE_DIR "${Slicer3_INSTALL_INCLUDE_DIR}/Plugins")
set(Slicer3_INSTALL_PLUGINS_SHARE_DIR "${Slicer3_INSTALL_SHARE_DIR}/Plugins")
set(Slicer3_INSTALL_PLUGINS_CACHE_DIR "${Slicer3_INSTALL_LIB_DIR}/PluginsCache")

set(Slicer3_INSTALL_MODULES_BIN_DIR "${Slicer3_INSTALL_LIB_DIR}/Modules")
set(Slicer3_INSTALL_MODULES_LIB_DIR "${Slicer3_INSTALL_LIB_DIR}/Modules")
set(Slicer3_INSTALL_MODULES_INCLUDE_DIR "${Slicer3_INSTALL_INCLUDE_DIR}/Modules")
set(Slicer3_INSTALL_MODULES_SHARE_DIR "${Slicer3_INSTALL_SHARE_DIR}/Modules")

set(Slicer3_HOME "${Slicer3_BINARY_DIR}")

#-----------------------------------------------------------------------------
# Disable the warnings that DevStudio 2005 emits wrt to sprintf, strcpu, etc.
#
# On Visual Studio 8 MS deprecated C. This removes all 1.276E1265 security
# warnings (copied from ITK's CMake files so that ITK templated code will compile
# correctly).
IF(WIN32)
  IF(NOT BORLAND)
    IF(NOT CYGWIN)
      IF(NOT MINGW)
        ADD_DEFINITIONS(
          -D_CRT_FAR_MAPPINGS_NO_DEPRECATE
          -D_CRT_IS_WCTYPE_NO_DEPRECATE
          -D_CRT_MANAGED_FP_NO_DEPRECATE
          -D_CRT_NONSTDC_NO_DEPRECATE
          -D_CRT_SECURE_NO_DEPRECATE
          -D_CRT_SECURE_NO_DEPRECATE_GLOBALS
          -D_CRT_SETERRORMODE_BEEP_SLEEP_NO_DEPRECATE
          -D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
          -D_CRT_VCCLRIT_NO_DEPRECATE
          -D_SCL_SECURE_NO_DEPRECATE
          )
      ENDIF(NOT MINGW)
    ENDIF(NOT CYGWIN)
  ENDIF(NOT BORLAND)
ENDIF(WIN32)


# include a test for endianness (used to be done by default)

include(${CMAKE_ROOT}/Modules/TestBigEndian.cmake)
test_big_endian(CMAKE_WORDS_BIGENDIAN)

#-----------------------------------------------------------------------------
# avoid linker bug in Mac OS 10.5
# see:
# http://wiki.finkproject.org/index.php/Fink:Packaging:Preparing_for_10.5#OpenGL_Bug
#
if(APPLE)
  set(CMAKE_SHARED_LINKER_FLAGS "-Wl,-dylib_file,/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib:/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib")
  set(CMAKE_EXE_LINKER_FLAGS "-Wl,-dylib_file,/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib:/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib")
endif(APPLE)

#-----------------------------------------------------------------------------
# Slicer version number.
#
set(Slicer3_VERSION_MAJOR "3")
set(Slicer3_VERSION_MINOR "6")
if(NOT Slicer3_VERSION_PATCH)
  set(Slicer3_VERSION_PATCH "3")
endif(NOT Slicer3_VERSION_PATCH)
set(Slicer3_VERSION "${Slicer3_VERSION_MAJOR}.${Slicer3_VERSION_MINOR}")
set(Slicer3_VERSION_FULL "${Slicer3_VERSION}.${Slicer3_VERSION_PATCH}")

#-----------------------------------------------------------------------------
# Build shared lib by default
#
option(BUILD_SHARED_LIBS "Build Slicer3 with shared libraries." ON)

#-----------------------------------------------------------------------------
# Append the library version information to the library target properties.
#
OPTION(Slicer3_WITH_LIBRARY_VERSION "Build with library version information" OFF)
IF(Slicer3_WITH_LIBRARY_VERSION)
  SET(Slicer3_LIBRARY_PROPERTIES ${Slicer3_LIBRARY_PROPERTIES}
    VERSION ${Slicer3_VERSION_FULL}
    SOVERSION ${Slicer3_VERSION}
  )
ENDIF(Slicer3_WITH_LIBRARY_VERSION)

#-----------------------------------------------------------------------------
# Slicer3 macros
#
set(Slicer3_CMAKE_DIR "${Slicer3_SOURCE_DIR}/CMake" CACHE INTERNAL "")
add_subdirectory(CMake)
# Make sure VTK_CMAKE_DIR is at the beginning so that VTK's FindTCL is
# used before CMake's FindTCL.
set(CMAKE_MODULE_PATH "${VTK_CMAKE_DIR}" ${CMAKE_MODULE_PATH} "${Slicer3_CMAKE_DIR}")

include("${Slicer3_CMAKE_DIR}/Slicer3PersistenceMacros.cmake")

# See http://www.cmake.org/Wiki/CMakeMacroParseArguments
include("${Slicer3_CMAKE_DIR}/Slicer3ParseArgumentsMacro.cmake")

## QT
INCLUDE(${Slicer3_CMAKE_DIR}/Slicer3FindQT.cmake)

#-----------------------------------------------------------------------------
# Top level slicer3 configurations
#
# If CMake >= 2.6.0
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")


# Do NOT force into the cache, as plugins need to override locally and scoping
# becomes an issue.
#set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/ 
#  CACHE PATH "Single output directory for building all libraries." FORCE)
#set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/ 
#  CACHE PATH "Single output directory for building all executables." FORCE)

#-----------------------------------------------------------------------------
# Slicer include and libraries subdirectory
#
slicer3_set_persistent_property(Slicer3_Libs_LIBRARIES "")
slicer3_set_persistent_property(Slicer3_Base_LIBRARIES "")
slicer3_set_persistent_property(Slicer3_Modules_LIBRARIES "")
slicer3_set_persistent_property(Slicer3_QTModules_LIBRARIES "")

slicer3_set_persistent_property(Slicer3_Libs_INCLUDE_DIRS "")
slicer3_set_persistent_property(Slicer3_Base_INCLUDE_DIRS "")
slicer3_set_persistent_property(Slicer3_Modules_INCLUDE_DIRS "")
slicer3_set_persistent_property(Slicer3_QTModules_INCLUDE_DIRS "")

#-----------------------------------------------------------------------------
# Get sytem name and architecture
#
SET(Slicer3_BUILD NA)
INCLUDE(${Slicer3_CMAKE_DIR}/DiscoverSystemNameAndBits.cmake)
MESSAGE(STATUS "Slicer3_BUILD:${Slicer3_BUILD}")

#-----------------------------------------------------------------------------
# Add the testing directories
#
OPTION(BUILD_TESTING "Test the project" ON)
SET(Slicer3_BUILD_TESTING ${BUILD_TESTING})
SET(LAUNCH_EXE ${Slicer3_BINARY_DIR}/Slicer3 --launch)
IF(Slicer3_BUILD_TESTING)
  #IF (NOT BUILDNAME)
  #  SET(BUILDNAME "${Slicer3_BUILD}" CACHE STRING "Name of build on the dashboard")
  #ELSE()
  #  SET(BUILDNAME "${BUILDNAME}" CACHE STRING "Name of build on the dashboard")
  #ENDIF()
  ENABLE_TESTING()
  INCLUDE(CTest)
  SET(CXX_TEST_PATH ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
  MARK_AS_ADVANCED(TCL_TCLSH DART_ROOT)

#-----------------------------------------------------------------------------
# Run test through valgrind: particularly useful for testing modules.
#
option(USE_VALGRIND "Run tests through valgrind." OFF)

ENDIF(Slicer3_BUILD_TESTING)

#-----------------------------------------------------------------------------
# By default, build with KWWidget
#
option(Slicer3_USE_KWWIDGETS "Build Slicer3 with KWWidgets." ON)

#-----------------------------------------------------------------------------
# Since modules are KWWidgets based, unset there variables
IF (NOT Slicer3_USE_KWWIDGETS)
  # Since the module Logic is shared between QTModules and regular Modules,
  # the associated BIN and LIB directory shouldn't be unset
  #UNSET(Slicer3_INSTALL_MODULES_BIN_DIR)
  #UNSET(Slicer3_INSTALL_MODULES_LIB_DIR)
  UNSET(Slicer3_INSTALL_MODULES_INCLUDE_DIR)
  UNSET(Slicer3_INSTALL_MODULES_SHARE_DIR)
ENDIF (NOT Slicer3_USE_KWWIDGETS)

#-----------------------------------------------------------------------------
# Libs
# - ITK
# - KWWidgets (pulls in VTK)
#

# Relax some constraints related to the build settings file. This was
# preventing people from using the same compiler but with a different generator,
# or just the same compiler installed in a non-standard location.

IF (Slicer3_USE_KWWIDGETS)
  set(SKIP_KWWidgets_BUILD_SETTINGS_FILE 1)
ENDIF(Slicer3_USE_KWWIDGETS)
set(SKIP_VTK_BUILD_SETTINGS_FILE 1)
set(SKIP_ITK_BUILD_SETTINGS_FILE 1)
set(SKIP_Teem_BUILD_SETTINGS_FILE 1)

#-----------------------------------------------------------------------------
## Python
option(Slicer3_USE_PYTHON "Integrate a python interpreter into Slicer." OFF)
if(Slicer3_USE_PYTHON)
  find_package(PythonLibs)
endif(Slicer3_USE_PYTHON)

#-----------------------------------------------------------------------------
## ITK
find_package(ITK REQUIRED)
if(NOT ITK_FOUND)
  message(FATAL_ERROR "Need ITK to build")
endif(NOT ITK_FOUND)
include(${ITK_USE_FILE})

#-----------------------------------------------------------------------------
IF (Slicer3_USE_KWWIDGETS)
  ## KWWidgets
  FIND_PACKAGE(KWWidgets REQUIRED)
  IF(NOT KWWidgets_FOUND)
    MESSAGE(FATAL_ERROR "Need KWWidgets to build")
  ENDIF(NOT KWWidgets_FOUND)
  INCLUDE(${KWWidgets_USE_FILE})
ELSE(Slicer3_USE_KWWIDGETS)
  FIND_PACKAGE(VTK REQUIRED)
  IF(NOT VTK_FOUND)
    MESSAGE(FATAL_ERROR "Need VTK to build with ")
  ELSE(NOT VTK_FOUND)
    IF(NOT VTK_USE_QVTK)
      MESSAGE("Please make sure VTK is build with VTK_USE_GUISUPPORT and VTK_USE_QVTK enabled")
    ENDIF(NOT VTK_USE_QVTK)
  ENDIF(NOT VTK_FOUND)
  INCLUDE(${VTK_USE_FILE})
ENDIF (Slicer3_USE_KWWIDGETS)

#-----------------------------------------------------------------------------
# Slicer3 is built with cvs head
#
option(Slicer3_USE_VTK_CVSHEAD "Slicer3 is configurated with cvs head." OFF)
mark_as_advanced(Slicer3_USE_VTK_CVSHEAD)

#-----------------------------------------------------------------------------
#
# Call macro defined in ${PROJECT_SOURCE_DIR}/CMake/Slicer3FindQT.cmake
#
SLICER3_SETUP_QT()

#-----------------------------------------------------------------------------
# Alert the user if both Slicer3_USE_QT and Slicer3_USE_KWWIDGETS are OFF
IF(NOT Slicer3_USE_QT AND NOT Slicer3_USE_KWWIDGETS)
  MESSAGE(FATAL_ERROR "Both Slicer3_USE_QT and Slicer3_USE_KWWIDGETS are OFF. Please, choose one")
ENDIF(NOT Slicer3_USE_QT AND NOT Slicer3_USE_KWWIDGETS)

#-----------------------------------------------------------------------------
# If Slicer3_USE_QT is ON and Slicer3_USE_KWWIDGETS is OFF, complain if VTK_WRAP_TCL is ON
# Note: Later on we will expect VTK_WRAP_PYTHON to be ON
IF(Slicer3_USE_QT AND NOT Slicer3_USE_KWWIDGETS)
  IF(VTK_WRAP_TCL)
    MESSAGE(FATAL_ERROR "For now, if Slicer3_USE_QT is ON and Slicer3_USE_KWWIDGETS is OFF, we expect VTK_WRAP_TCL to be OFF")
  ENDIF(VTK_WRAP_TCL)
ENDIF(Slicer3_USE_QT AND NOT Slicer3_USE_KWWIDGETS)

#-----------------------------------------------------------------------------
# Add Slicer3_USE_PYTHONQT option if Slicer3_USE_QT is ON
IF(Slicer3_USE_QT)
  option(Slicer3_USE_PYTHONQT "Integrate a python-QT interpreter into Slicer." OFF)
  IF(Slicer3_USE_PYTHONQT)
    IF(NOT VTK_WRAP_PYTHON)
      MESSAGE(FATAL_ERROR "Since both Slicer3_USE_QT and Slicer3_USE_PYTHONQT are ON, VTK_WRAP_PYTHON is expected to be ON. Disable Slicer3_USE_PYTHONQT or re-configure VTK with python wrapping.")
    ENDIF(NOT VTK_WRAP_PYTHON)
    # Enable qCTKWidgets python wrapping
    # Note that qVTKWidgets and qMRMLWidgets python wrapping will be automatically enabled
    SET(qCTKWidgets_WRAP_PYTHON ON)
  ENDIF(Slicer3_USE_PYTHONQT)
ENDIF(Slicer3_USE_QT)  

#-----------------------------------------------------------------------------
## Teem
find_package(Teem REQUIRED)
if(NOT Teem_FOUND)
  message(FATAL_ERROR "Need Teem to build")
endif(NOT Teem_FOUND)
include(${Teem_USE_FILE})

#-----------------------------------------------------------------------------
## SlicerLibCurl
find_package(SLICERLIBCURL REQUIRED)
if(SLICERLIBCURL_FOUND)
  include(${SLICERLIBCURL_USE_FILE})
endif(SLICERLIBCURL_FOUND)

=== Applications/CMakeLists.txt ===
PROJECT(Applications)

IF(Slicer3_BUILD_CLI)
  ADD_SUBDIRECTORY(CLI)
ENDIF(Slicer3_BUILD_CLI)

IF (Slicer3_USE_KWWIDGETS)
  ADD_SUBDIRECTORY(GUI)
ENDIF (Slicer3_USE_KWWIDGETS)

IF(Slicer3_USE_QT)
  ADD_SUBDIRECTORY(SlicerQT)
ENDIF(Slicer3_USE_QT)

IF(Slicer3_BUILD_TESTING)
  ADD_SUBDIRECTORY(Testing)
ENDIF(Slicer3_BUILD_TESTING)

=== Base/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)
MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY)


# Calling PROJECT() defines projectname_SOURCE_DIR and projectname_BINARY_DIR
PROJECT(SlicerBase)

INCLUDE(${Slicer3_CMAKE_DIR}/Slicer3QTBaseLibraryMacros.cmake)

INCLUDE_DIRECTORIES(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/QTCore
  ${CMAKE_CURRENT_SOURCE_DIR}/QTBase
  ${CMAKE_CURRENT_BINARY_DIR}/QTCore
  )

ADD_SUBDIRECTORY(Logic)

IF(Slicer3_USE_QT)
  ADD_SUBDIRECTORY(QTBase)
  ADD_SUBDIRECTORY(QTCLI)
  ADD_SUBDIRECTORY(QTCoreModules)
  ADD_SUBDIRECTORY(QTCore)
  ADD_SUBDIRECTORY(QTGUI)
ENDIF(Slicer3_USE_QT)

IF (Slicer3_USE_KWWIDGETS)
  ADD_SUBDIRECTORY(GUI)
ENDIF (Slicer3_USE_KWWIDGETS)

ADD_SUBDIRECTORY(CLI)

IF(Slicer3_USE_PYTHONQT)
  ADD_SUBDIRECTORY(Python)
ENDIF(Slicer3_USE_PYTHONQT)

=== CMake/CMakeLists.txt ===
FILE(GLOB cmake_files "${CMAKE_CURRENT_SOURCE_DIR}/*.cmake")
INSTALL(
  FILES ${cmake_files}
  DESTINATION ${Slicer3_INSTALL_LIB_DIR}/CMake COMPONENT Development
  )

=== Libs/CMakeLists.txt ===
project(SlicerLibs)

## Delegate the building of the SlicerExecutionModel to
## a bundled subdirectory that can easily be included in
## other packages.
set(ModuleDescriptionParser_USE_PYTHON ${Slicer3_USE_PYTHON})
ADD_SUBDIRECTORY(SlicerExecutionModel)

set(dirs
# FileWatcher
  )

IF(Slicer3_USE_KWWIDGETS)
  SET(dirs ${dirs}
    LoadableModule
    )
ENDIF(Slicer3_USE_KWWIDGETS)

# Note: Order of of SUBDIRS is important if your projects depend
# on code in other projects (put dependent project later).

if(Teem_FOUND)
  set(dirs ${dirs} vtkTeem)
endif(Teem_FOUND)

SET(dirs ${dirs}
  vtkITK
  FreeSurfer
  MRML
  MRMLCLI
  )

IF(Slicer3_USE_KWWIDGETS)
  SET(dirs ${dirs}
    GenerateLM
    SlicerIO
    ITKCommandIO
    )
ENDIF(Slicer3_USE_KWWIDGETS)

SET(dirs ${dirs}
  MRMLIDImageIO
  MGHImageIO
  IGT
  RemoteIO
  #SIGN
  )



#-----------------------------------------------------------------------------
# QT related libraries
#
IF(Slicer3_USE_QT)
set(dirs ${dirs}
  qCTKWidgets
  qVTKWidgets
  qMRMLWidgets
  )
ENDIF(Slicer3_USE_QT)

#-----------------------------------------------------------------------------
# CUDA
#
INCLUDE(${CMAKE_SOURCE_DIR}/CMake/cuda/FindCuda.cmake)

IF(FOUND_CUDA AND FOUND_CUDART AND FOUND_CUT)
   OPTION(CUDA_SUPPORT_ENABLED "If Cuda Support should be integrated into Slicer. You have to configure once again to see the other availiable options" ON)
ELSE(FOUND_CUDA AND FOUND_CUDART AND FOUND_CUT)
   OPTION(CUDA_SUPPORT_ENABLED "If Cuda Support should be integrated into Slicer. You have to configure once again to see the other availiable options" OFF)
ENDIF(FOUND_CUDA AND FOUND_CUDART AND FOUND_CUT)

IF(CUDA_SUPPORT_ENABLED)
  set (dirs ${dirs} CudaSupport)
ENDIF(CUDA_SUPPORT_ENABLED)

#-----------------------------------------------------------------------------
# Set library properties
#
set(include_dirs)
set(libs)

set(LoadableModule_USE_PYTHON ${Slicer3_USE_PYTHON})

set(IGT_USE_IGSTK ${Slicer3_USE_IGSTK})
set(IGT_USE_NAVITRACK ${Slicer3_USE_NAVITRACK})
set(ITKCommandIO_INSTALL_ITKFACTORIES_DIR ${Slicer3_INSTALL_ITKFACTORIES_DIR})
set(MGHImageIO_INSTALL_ITKFACTORIES_DIR ${Slicer3_INSTALL_ITKFACTORIES_DIR})
set(MRMLIDImageIO_INSTALL_ITKFACTORIES_DIR ${Slicer3_INSTALL_ITKFACTORIES_DIR})

foreach(dir ${dirs})

  set(include_dirs ${include_dirs}
    ${CMAKE_CURRENT_SOURCE_DIR}/${dir}
    ${CMAKE_CURRENT_BINARY_DIR}/${dir}
    )

  set(libs ${libs} ${dir})
endforeach(dir)

# vtkITK contains tests that uses MRML's test data.
set(MRML_TEST_DATA_DIR ${CMAKE_CURRENT_SOURCE_DIR}/MRML/Testing/TestData)

slicer3_get_persistent_property(Slicer3_Libs_INCLUDE_DIRS tmp)
slicer3_set_persistent_property(Slicer3_Libs_INCLUDE_DIRS ${tmp} ${include_dirs})
# Inconsistent library name vs. project/dir name :(

string(REPLACE ITKCommandIO CommandIO libs "${libs}")
IF(Slicer3_USE_KWWIDGETS)
  string(REPLACE SlicerIO slicerio libs "${libs}")
ENDIF(Slicer3_USE_KWWIDGETS)
string(REPLACE MGHImageIO MGHIO libs "${libs}")
string(REPLACE MRMLIDImageIO MRMLIDIO libs "${libs}")

# Those are not libs

list(REMOVE_ITEM libs GenerateLM slicerio)

slicer3_get_persistent_property(Slicer3_Libs_LIBRARIES tmp)
slicer3_set_persistent_property(Slicer3_Libs_LIBRARIES ${tmp} ${libs})

FOREACH(dir ${dirs})
  ADD_SUBDIRECTORY(${dir})
ENDFOREACH(dir)

=== Modules/CMakeLists.txt ===
project(Modules)

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)
MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY)

 
if(NOT Slicer3_SOURCE_DIR)
  find_package(Slicer3 REQUIRED)
  include(${Slicer3_USE_FILE})
  slicer3_set_default_install_prefix_for_external_projects()
endif(NOT Slicer3_SOURCE_DIR)

find_package(GenerateLM REQUIRED)
if(GenerateLM_FOUND)
  include(${GenerateLM_USE_FILE})
endif(GenerateLM_FOUND)

# Dependencies (to be untangled later, for now the whole directory has to
# be built at the same time)
#
# Volumes:
#   - CommandLineModule
#   - Tractography (SlicerTractographyDisplay, SlicerTractographyFiducialSeeding)
# EMSegment:
#   - Volumes
#   - CommandLineModule (at run-time for its CLP Plugins: EMSegmentCommandLine*)
# QueryAtlas:
# MRAblation (if it wasn't broken):
#   - Volumes
# Editor:
#   - ScriptedModule (at run-time for its Tcl package)
# Meshing:
#   - CommandLineModule (at run-time for its CLP Plugins: VoxelMeshModule)
# Python:
#   - CommandLineModule or ScriptedModule (at run-time for its Python Plugins)
# PythonGADScriptedModule:
#   - ScriptedModule (at run-time for its Python scripts)
# SlicerDaemon:
#   - ScriptedModule (at run-time for its Tcl package)

SET(modules
  AtlasCreator
  CommandLineModule
  Editor
  Endoscopy
  GradientAnisotropicDiffusionFilter
  Meshing
  Python
# PythonGADScriptedModule
  QueryAtlas
  FetchMI
  SlicerWelcome
  DiffusionWelcome
  RegistrationWelcome
  SegmentationWelcome
  ScriptedModule
  ScriptedModuleExample
  SlicerDaemon
  Statistics
  Tractography
# TumorGrowth
  Volumes
  ChangeTracker # AF: refactoring TumorGrowth...
  VolumeRendering
#  VolumeRendering1 <- merged into VolumeRendering
# WFEngineModule  <- can't work with 2.6 and Win32??
# MRAblation <- not working either
  ModelMirror
  ModelTransform
  EMSegment
  # DistanceTransformModel <- culled from slicer 3.6
  ClipModel
  Measurements
  ModelIntoLabelVolume
# ExtractSubvolume <- replaced by ExtractSubvolumeROI
  FastMarchingSegmentation
  FourDImage
#  FourDAnalysis
#  ExtractSubvolumeROI <- renamed to CropVolume
  CropVolume
  CollectFiducials
  PETCTFusion
  IGTToolSelector
  )

if(Slicer3_USE_OPENIGTLINK)
  SET(modules
    ${modules}
    OpenIGTLinkIF
    NeuroNav
    ProstateNav
    # IGTNavigation
    # OpenCV
    )
endif(Slicer3_USE_OPENIGTLINK)

FOREACH(module ${modules})
  ADD_SUBDIRECTORY(${module})
ENDFOREACH(module)

## SLICES_DEBUG
## GAD_DEBUG
## MODELS_DEBUG
## VOLUMES_DEBUG
## QUERYATLAS_DEBUG
## FETCHMI_DEBUG
## WELCOME_DEBUG
## COLORS_DEBUG
## FIDUCIALS_DEBUG
## CAMERA_DEBUG
## EMSEG_DEBUG
## REALTIMEIMAGING_DEBUG
## MRABLATION_DEBUG
## TRACTOGRAPHY_DEBUG
## COMMANDLINE_DEBUG
## DEAMON_DEBUG

if(Slicer3_BUILD_TESTING)
  ADD_SUBDIRECTORY(Testing)
endif(Slicer3_BUILD_TESTING)

=== Resources/CMakeLists.txt ===
file(GLOB HEADERFILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "*.h")
foreach(headerfile ${HEADERFILES})
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/${headerfile}
    "${CMAKE_BINARY_DIR}/${Slicer3_INSTALL_SHARE_DIR}/Resources/${headerfile}"
    COPYONLY
    )
endforeach(headerfile)

install(
  FILES ${HEADERFILES}
  DESTINATION ${Slicer3_INSTALL_SHARE_DIR}/Resources COMPONENT Development
  )

file(GLOB PNGFILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "*.png")
foreach(pngfile ${PNGFILES})
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/${pngfile}
    "${CMAKE_BINARY_DIR}/${Slicer3_INSTALL_SHARE_DIR}/Resources/${pngfile}"
    COPYONLY
    )
endforeach(pngfile)

install(
  FILES ${PNGFILES}
  DESTINATION ${Slicer3_INSTALL_SHARE_DIR}/Resources
  )


# Should this location change, update somewhere

file(GLOB PARAMETERSETS RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "ParameterSets/*.mrml")

foreach(parameterset ${PARAMETERSETS})
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/${parameterset}
    "${CMAKE_BINARY_DIR}/${Slicer3_INSTALL_SHARE_DIR}/Resources/${parameterset}"
    COPYONLY
    )
endforeach(parameterset)
install(
  FILES ${PARAMETERSETS}
  DESTINATION ${Slicer3_INSTALL_SHARE_DIR}/Resources/ParameterSets
  )

=== SuperBuild/CMakeLists.txt ===

#-----------------------------------------------------------------------------
cmake_minimum_required(VERSION 2.8)
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
project(Slicer3)
#-----------------------------------------------------------------------------

enable_language(C)
enable_language(CXX)

#-----------------------------------------------------------------------------
# See http://cmake.org/cmake/help/cmake-2-8-docs.html#section_Policies for details
#-----------------------------------------------------------------------------

SET(project_policies
  #CMP0001 # NEW: CMAKE_BACKWARDS_COMPATIBILITY should no longer be used.
  #CMP0002 # NEW: Logical target names must be globally unique.
  CMP0003 # NEW: Libraries linked via full path no longer produce linker search paths.
  #CMP0004 # NEW: Libraries linked may NOT have leading or trailing whitespace.
  #CMP0005 # NEW: Preprocessor definition values are now escaped automatically.
  #CMP0006 # NEW: Installing MACOSX_BUNDLE targets requires a BUNDLE DESTINATION.
  #CMP0007 # NEW: List command no longer ignores empty elements.
  #CMP0008 # NEW: Libraries linked by full-path must have a valid library file name.
  #CMP0009 # NEW: FILE GLOB_RECURSE calls should not follow symlinks by default.
  #CMP0010 # NEW: Bad variable reference syntax is an error.
  #CMP0011 # NEW: Included scripts do automatic cmake_policy PUSH and POP.
  #CMP0012 # NEW: if() recognizes numbers and boolean constants.
  #CMP0013 # NEW: Duplicate binary directories are not allowed.
  #CMP0014 # NEW: Input directories must have CMakeLists.txt
  )
FOREACH(policy ${project_policies})
  IF(POLICY ${policy})
    CMAKE_POLICY(SET ${policy} NEW)
  ENDIF()
ENDFOREACH()


#-----------------------------------------------------------------------------
# Platform check
#-----------------------------------------------------------------------------

set(PLATFORM_CHECK true)

if(PLATFORM_CHECK)
  # See CMake/Modules/Platform/Darwin.cmake)
  #   6.x == Mac OSX 10.2 (Jaguar)
  #   7.x == Mac OSX 10.3 (Panther)
  #   8.x == Mac OSX 10.4 (Tiger)
  #   9.x == Mac OSX 10.5 (Leopard)
  #  10.x == Mac OSX 10.6 (Snow Leopard)
  if (DARWIN_MAJOR_VERSION LESS "8")
    message(FATAL_ERROR "Only Mac OSX >= 10.4 are supported !")
  endif()
endif()

#-----------------------------------------------------------------------------
# Update CMake module path
#------------------------------------------------------------------------------

set(CMAKE_MODULE_PATH
  ${CMAKE_SOURCE_DIR}/CMake
  ${CMAKE_BINARY_DIR}/CMake
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/../CMake # Slicer3 CMake directory
  ${CMAKE_MODULE_PATH}
  )

#-----------------------------------------------------------------------------
# Convenient macro allowing to download a file
#------------------------------------------------------------------------------

FUNCTION(downloadFile url dest)
  FILE(DOWNLOAD ${url} ${dest} STATUS status)
  LIST(GET status 0 error_code)
  LIST(GET status 1 error_msg)
  IF(error_code OR NOT EXISTS ${dest})
    MESSAGE(FATAL_ERROR "error: Failed to download ${url}")
  ENDIF()
ENDFUNCTION()

#-----------------------------------------------------------------------------
# Prerequisites
#------------------------------------------------------------------------------

option(Slicer3_USE_GIT_PROTOCOL "If behind a firewall turn this off to use http instead." ON)

set(git_protocol "git")
if(NOT Slicer3_USE_GIT_PROTOCOL)
  set(git_protocol "http")
endif()

set(git_repo http://github.com/commontk/CTK/raw/master/)
set(file CMake/ExternalProject.cmake)
downloadFile(${git_repo}/${file} ${CMAKE_BINARY_DIR}/${file})

#-----------------------------------------------------------------------------
# Include External project module
#------------------------------------------------------------------------------

set(base "${CMAKE_BINARY_DIR}/CMakeExternals")
set(prefix "${base}/Install")

include(ExternalProject)

# Compute -G arg for configuring external projects with the same CMake generator:
if(CMAKE_EXTRA_GENERATOR)
  set(gen "${CMAKE_EXTRA_GENERATOR} - ${CMAKE_GENERATOR}")
else()
  set(gen "${CMAKE_GENERATOR}")
endif()

#-----------------------------------------------------------------------------
# Disable the warnings that DevStudio 2005 emits wrt to sprintf, strcpu, etc.
#------------------------------------------------------------------------------

# Disable warnings that DevStudio 2005 emits wrt to sprintf, strcpu, etc.
if(CMAKE_COMPILER_2005)
  add_definitions(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE)
endif()

# DevStudio 9.0 - Disable warning C4996: [...] This function or variable may be unsafe. [...]
# To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details
if(MSVC90)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif(MSVC90)

#-----------------------------------------------------------------------------
# Always build Shared library
#------------------------------------------------------------------------------

set(BUILD_SHARED_LIBS ON)

#-----------------------------------------------------------------------------
# Setup build type
#------------------------------------------------------------------------------

# By default, let's build as Debug
if(NOT DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Debug")
endif()

# let a dashboard override the default.
if(CTEST_BUILD_CONFIGURATION)
  set(CMAKE_BUILD_TYPE "${CTEST_BUILD_CONFIGURATION}")
endif()


#-----------------------------------------------------------------------------
# Slicer Options
#-----------------------------------------------------------------------------

#
#                         ----------------------------
#                         | Case 1 | Case 2 | Case 3 |
# ----------------------------------------------------
# | MAC{32,64}{Tiger,Leo} |  ON    |   -    |  OK    |
# ----------------------------------------------------
# | WIN{32,64} VS2008     |  OK    |  OK    |  OK    |
# ----------------------------------------------------
# | Linux{32,64}          |  OK    |  OK    |  OK    |
# ----------------------------------------------------
# ----------------------------------------------------
# | Slicer3_USE_KWWIDGETS |  ON    |  ON    |  OFF   |
# |---------------------------------------------------
# | Slicer3_USE_QT        |  OFF   |  ON    |  ON    |
# |--------------------------------------------------|
# | Slicer3_USE_PYTHON    | ON|OFF | ON|OFF |  OFF   |
# |--------------------------------------------------|
# | Slicer3_USE_PYTHONQT  |   OFF  |  OFF   | ON|OFF |
# |---------------------------------------------------

#
# Case 1: [Slicer3_USE_KWWIDGETS: ON, Slicer3_USE_QT: OFF, VTK_WRAP_TCL:ON]
#   a) KwwOnly-NoPython  
#   b) KwwOnly-Python    
# 
# Case 2: [Slicer3_USE_KWWIDGETS: ON, Slicer3_USE_QT: ON, VTK_WRAP_TCL:ON]
#   a) KwwAndQt-NoPython-NoPythonQt
#   b) KwwAndQt-Python
#   c) KwwAndQt-PythonQt          [VTK_WRAP_PYTHON: ON]  -> NOT SUPPORTED
#   d) KwwAndQt-Python-PythonQt                          -> NOT SUPPORTED
#
# Case 3: [Slicer3_USE_KWWIDGETS: OFF, Slicer3_USE_QT: ON,  VTK_WRAP_TCL:OFF]
#   a) QtOnly-NoPythonQt
#   b) QtOnly-PythonQt            [VTK_WRAP_PYTHON: ON]
#
#
# Note:
#   Tcl, Tk, blt, incrTcl and iwidgets are build only if Slicer3_USE_KWWIDGETS is ON
#   Python is build if either Slicer3_USE_PYTHON or Slicer3_USE_PYTHONQT are ON
# 

#------------------------------------------------------------------------------
# KWWidgets option
#------------------------------------------------------------------------------  

# KWWidgets on by default.
option(Slicer3_USE_KWWIDGETS "Build Slicer3 KWWidgets GUI" ON)


#------------------------------------------------------------------------------
# Qt option
#------------------------------------------------------------------------------  

option(Slicer3_USE_QT  "Build Slicer3 Qt GUI" OFF)

if(Slicer3_USE_QT)
  set(minimum_required_qt_version "4.6.2")
  # For Mac OS X 10.6, Apple has started recommending developers to build their applications 64-bit.
  # The main reason is that there is a small speed increase due to the extra registers on Intel 
  #CPU's, all their machine offerings have been 64-bit since 2007, and there is a cost for reading 
  # all the 32-bit libraries into memory if everything else is 64-bit. If you want to follow this
  # advice, there is only one choice, 64-bit Cocoa.
  #
  # See CMake/Modules/Platform/Darwin.cmake)
  #   6.x == Mac OSX 10.2 (Jaguar)
  #   7.x == Mac OSX 10.3 (Panther)
  #   8.x == Mac OSX 10.4 (Tiger)
  #   9.x == Mac OSX 10.5 (Leopard)
  #  10.x == Mac OSX 10.6 (Snow Leopard)

  if(DARWIN_MAJOR_VERSION GREATER "10")
    set(minimum_required_qt_version "4.7.0")
  endif()
  
  find_package(Qt4)
  
  if(QT4_FOUND)
    
    set(current_qt_version "${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}.${QT_VERSION_PATCH}")
  
    if("${current_qt_version}" VERSION_LESS "${minimum_required_qt_version}")
      message(FATAL_ERROR "error: Slicer requires Qt >= ${minimum_required_qt_version} -- you cannot use Qt ${current_qt_version}.")
    endif()
  
    # Enable modules
    SET(QT_USE_QTNETWORK ON)
    
    # Includes Qt headers
    INCLUDE(${QT_USE_FILE})

    option(Slicer3_USE_PYTHONQT "Integrate a python-QT interpreter into Slicer." OFF)
  
  else()
    MESSAGE(FATAL_ERROR "error: Qt >= ${minimum_required_qt_version} was not found on your system. You probably need to set the QT_QMAKE_EXECUTABLE variable")
  endif()
  
endif()
  
#------------------------------------------------------------------------------
# Python option
#------------------------------------------------------------------------------  

option(Slicer3_USE_PYTHON "Build Slicer with Python support" ON)

if(Slicer3_USE_PYTHON OR Slicer3_USE_PYTHONQT)

  option(Slicer3_BUILD_NUMPY "Build Slicer with NumPy (builds CLapack)." ON)

  # Work in progress ...
  #if(Slicer3_BUILD_NUMPY)
  #  option(Slicer3_BUILD_SCIPY "Build Slicer with SciPy (requires NumPy)" ON)
  #endif()
  
endif()

#------------------------------------------------------------------------------
# Additional options
#------------------------------------------------------------------------------  

# Enable VTK Debug Leaks
option(Slicer3_USE_VTK_DEBUG_LEAKS 
  "Turn on VTKs Debug Leaks functionality in both VTK and Slicer." ON)
  
#------------------------------------------------------------------------------
# Validate options
#------------------------------------------------------------------------------  

if (NOT Slicer3_USE_KWWIDGETS AND NOT Slicer3_USE_QT)
  set(err "error: Slicer SuperBuild requires at least Slicer3_USE_KWWIDGETS or Slicer3_USE_QT to be ON.

Slicer3_USE_KWWIDGETS = ON
 -> Means Slicer will be built only with KWWidgets support.
 
Slicer3_USE_KWWIDGETS = ON and Slicer3_USE_QT = ON
 -> Means Slicer will be built with both KWWidgets and QT support. Note: NOT supported on Mac
 
Slicer3_USE_QT = ON
 -> Means Slicer will be build only with QT support.
")

  message(FATAL_ERROR "${err}")
endif()

if (Slicer3_USE_PYTHON AND Slicer3_USE_PYTHONQT)
  set(err "error: Slicer SuperBuild doesn't support Slicer3_USE_PYTHON and Slicer3_USE_PYTHONQT ON.")
  message(FATAL_ERROR "${err}")
endif()

if (Slicer3_USE_KWWIDGETS AND Slicer3_USE_PYTHONQT)
  set(err "error: Slicer SuperBuild doesn't support Slicer3_USE_KWWIDGETS and Slicer3_USE_PYTHONQT ON.")
  message(FATAL_ERROR "${err}")
endif()

if (Slicer3_USE_KWWIDGETS AND Slicer3_USE_QT AND APPLE)
  set(err "error: Slicer SuperBuild on Mac doesn't support Slicer3_USE_KWWIDGETS and Slicer3_USE_QT ON")
  message(FATAL_ERROR "${err}")
endif()

#------------------------------------------------------------------------------
# Configure the CTest custom file - Used to suppress external project configure/build warnings

=== Applications/CLI/CMakeLists.txt ===
project( CLI )

#

find_package(GenerateCLP REQUIRED)
if(GenerateCLP_FOUND)
  include(${GenerateCLP_USE_FILE})
endif(GenerateCLP_FOUND)
find_package(vtkITK REQUIRED)

link_directories(${ModuleDescriptionParser_BINARY_DIR})

find_package(ITK REQUIRED)
include(${ITK_USE_FILE})

find_package(VTK REQUIRED)
include(${VTK_USE_FILE})

include_directories( ${SlicerBaseCLI_BINARY_DIR} ${SlicerBaseCLI_SOURCE_DIR} )
link_directories(${SlicerBaseCLI_BINARY_DIR})

#####################
set (CLP BSplineToDeformationField)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/ITKLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
slicer3_set_plugins_output_path(${CLP}Lib)
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
target_link_libraries (${CLP}Lib ITKIO ITKBasicFilters)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)


#####################
set (CLP DiffusionTensorTest)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/ITKLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
slicer3_set_plugins_output_path(${CLP}Lib)
target_link_libraries (${CLP}Lib ITKIO)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)

#####################
set (CLP DiffusionWeightedTest)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/ITKLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
slicer3_set_plugins_output_path(${CLP}Lib)
target_link_libraries (${CLP}Lib ITKIO ITKBasicFilters)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)


#####################
set (CLP DiffusionTensorEstimation)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/ITKLogo.h)
add_executable(${CLP} ${${CLP}_SOURCE})
slicer3_set_plugins_output_path(${CLP})
link_directories(${MRML_LIB_DIR} ${vtkTeem_LIB_DIR} ${SlicerBaseLogic_SOURCE_DIR}
  ${SlicerBaseLogic_BINARY_DIR})
target_link_libraries (${CLP} MRML vtkTeem SlicerBaseLogic)
include_directories(
  ${vtkITK_SOURCE_DIR} 
  ${vtkITK_BINARY_DIR} 
  ${MRML_SOURCE_DIR} ${MRML_BINARY_DIR} 
  ${vtkTeem_SOURCE_DIR}  ${vtkTeem_BINARY_DIR})

#####################
set (CLP DiffusionTensorMathematics)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/ITKLogo.h)
add_executable(${CLP} ${${CLP}_SOURCE})
slicer3_set_plugins_output_path(${CLP})
link_directories(${MRML_LIB_DIR} ${vtkTeem_LIB_DIR})
target_link_libraries (${CLP} MRML vtkTeem)
include_directories(
  ${MRML_SOURCE_DIR} ${MRML_BINARY_DIR} 
  ${vtkTeem_SOURCE_DIR}  ${vtkTeem_BINARY_DIR})

#####################
set (CLP OrientImage)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/NAMICLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
slicer3_set_plugins_output_path(${CLP}Lib)
target_link_libraries (${CLP}Lib ITKIO ITKBasicFilters)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)


#####################
set (CLP LinearRegistration)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/NAMICLogo.h)
add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
slicer3_set_plugins_output_path(${CLP}Lib)
target_link_libraries (${CLP}Lib ITKIO ITKBasicFilters ITKNumerics)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)

#####################
set (CLP RigidRegistration)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/NAMICLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
slicer3_set_plugins_output_path(${CLP}Lib)
target_link_libraries (${CLP}Lib ITKIO ITKBasicFilters ITKNumerics)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)

#####################
set (CLP AffineRegistration)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/NAMICLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
slicer3_set_plugins_output_path(${CLP}Lib)
target_link_libraries (${CLP}Lib ITKIO ITKBasicFilters ITKNumerics)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)

#####################
set (CLP BSplineDeformableRegistration)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/NAMICLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
slicer3_set_plugins_output_path(${CLP}Lib)
target_link_libraries (${CLP}Lib ITKStatistics ITKIO ITKBasicFilters ITKNumerics)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)

#####################
set (CLP TestGridTransformRegistration)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/NAMICLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
slicer3_set_plugins_output_path(${CLP}Lib)
target_link_libraries (${CLP}Lib ITKStatistics ITKIO ITKBasicFilters ITKNumerics)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)

#####################
set (CLP CheckerBoard)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml  ${Slicer3_SOURCE_DIR}/Resources/NAMICLogo.h)
add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
slicer3_set_plugins_output_path(${CLP}Lib)
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
target_link_libraries (${CLP}Lib ITKIO ITKBasicFilters)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)

#####################
set (CLP ResampleVolume)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/ITKLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
slicer3_set_plugins_output_path(${CLP}Lib)
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
target_link_libraries (${CLP}Lib ITKIO ITKBasicFilters)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)

#####################
set (CLP PolyDataToLabelmap)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/NAMICLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
slicer3_set_plugins_output_path(${CLP}Lib)
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
target_link_libraries (${CLP}Lib ITKIO vtkIO vtkGraphics ITKBasicFilters)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)

#####################
set (CLP GaussianBlurImageFilter)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/ITKLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
slicer3_set_plugins_output_path(${CLP}Lib)
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
target_link_libraries (${CLP}Lib ITKIO ITKBasicFilters)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)

#####################
set (CLP ConfidenceConnected)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/ITKLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
slicer3_set_plugins_output_path(${CLP}Lib)
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
target_link_libraries (${CLP}Lib ITKIO ITKBasicFilters)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)

#####################
set (CLP ExecutionModelTour)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/BillsLogo.h)
add_executable(${CLP} ${${CLP}_SOURCE})
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} MRML)

#####################


set (CLP ImageReadDicomWrite)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp (${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/ITKLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
slicer3_set_plugins_output_path(${CLP}Lib)
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
target_link_libraries (${CLP}Lib ITKIO ITKBasicFilters)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)

#####################
set (CLP CurvatureAnisotropicDiffusion)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/ITKLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
slicer3_set_plugins_output_path(${CLP}Lib)
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
target_link_libraries (${CLP}Lib ITKIO ITKBasicFilters)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)

#####################
set (CLP GradientAnisotropicDiffusion)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/ITKLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
slicer3_set_plugins_output_path(${CLP}Lib)
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
target_link_libraries (${CLP}Lib ITKIO ITKBasicFilters)

add_executable(${CLP} ${CLI_SOURCE_DIR}/Templates/CommandLineSharedLibraryWrapper.cxx)
slicer3_set_plugins_output_path(${CLP})
target_link_libraries (${CLP} ${CLP}Lib)
#####################
set (CLP MedianImageFilter)

set ( ${CLP}_SOURCE ${CLP}.cxx)
generateclp(${CLP}_SOURCE ${CLP}.xml ${Slicer3_SOURCE_DIR}/Resources/ITKLogo.h)

add_library(${CLP}Lib SHARED ${${CLP}_SOURCE})
slicer3_set_plugins_output_path(${CLP}Lib)
set_target_properties (${CLP}Lib PROPERTIES COMPILE_FLAGS "-Dmain=ModuleEntryPoint")
target_link_libraries (${CLP}Lib ITKIO ITKBasicFilters)

=== Applications/GUI/CMakeLists.txt ===
project(GUI)

# --------------------------------------------------------------------------
# Enable shared link forwarding support if needed.
#
get_filename_component(TCL_LIBRARY_PATH "${TCL_LIBRARY}" PATH)
get_filename_component(TCL_DIR "${TCL_LIBRARY_PATH}" PATH)
get_filename_component(INCR_TCL_LIBRARY_PATH "${INCR_TCL_LIBRARY}" PATH)
get_filename_component(INCR_TK_LIBRARY_PATH "${INCR_TK_LIBRARY}" PATH)

# Some people use Mesa instead of the default system OpenGL.
# Try to incorporate that in the launcher, but NOT for installation.

if(NOT WIN32)
  foreach(dependency ${vtkftgl_LIB_DEPENDS})
    get_filename_component(dependency_lib "${dependency}" NAME_WE)
    if(dependency_lib STREQUAL "libGL")
      get_filename_component(OPENGL_gl_LIBRARY_PATH "${dependency}" PATH)
    endif(dependency_lib STREQUAL "libGL")
  endforeach(dependency)
endif(NOT WIN32)

set(Slicer3_EXE_SUFFIX)
set(Slicer3_EXE_INSTALL ${Slicer3_INSTALL_BIN_DIR})
if(BUILD_SHARED_LIBS)
  set(Slicer3_NEED_SHARED_FORWARD 1)
  set(Slicer3_EXE_SUFFIX -real)
  set(Slicer3_EXE_INSTALL ".")
  set(Slicer3_FORWARD_DIR_BUILD "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")
  set(Slicer3_FORWARD_DIR_INSTALL "${Slicer3_EXE_INSTALL}")
  if(WIN32)
    set(Slicer3_FORWARD_PATH_BUILD 
      "\"${Slicer3_FORWARD_DIR_BUILD}\" CONFIG_DIR_POST,\"${VTK_DIR}/bin\" CONFIG_DIR_POST,\"${KWWidgets_RUNTIME_DIRS}\" CONFIG_DIR_POST,\"${ITK_DIR}/bin\" CONFIG_DIR_POST,\"${Teem_DIR}/bin\" CONFIG_DIR_POST,\"${TCL_DIR}/bin\",\"${INCR_TCL_LIBRARY_PATH}\",\"${INCR_TK_LIBRARY_PATH}\"")
    set(Slicer3_FORWARD_PATH_INSTALL
      "\"../lib/TclTk/bin\",\"../lib/TclTk/lib/itcl${INCR_TCL_VERSION_DOT}\",\"../lib/TclTk/lib/itk${INCR_TCL_VERSION_DOT}\"")
    if(Slicer3_BUILD_MODULES)
      set(Slicer3_FORWARD_PATH_BUILD 
        "${Slicer3_FORWARD_PATH_BUILD},\"${Slicer3_HOME}/${Slicer3_INSTALL_MODULES_BIN_DIR}\" CONFIG_DIR_POST")
    endif(Slicer3_BUILD_MODULES)
    if(Slicer3_BUILD_CLI)
      set(Slicer3_FORWARD_PATH_BUILD 
        "${Slicer3_FORWARD_PATH_BUILD},\"${Slicer3_HOME}/${Slicer3_INSTALL_PLUGINS_BIN_DIR}\" CONFIG_DIR_POST")
    endif(Slicer3_BUILD_CLI)
  else(WIN32)
    set(Slicer3_FORWARD_PATH_BUILD 
      "\"${Slicer3_FORWARD_DIR_BUILD}\",\"${VTK_DIR}/bin\",\"${KWWidgets_RUNTIME_DIRS}\",\"${ITK_DIR}/bin\",\"${Teem_DIR}/bin\",\"${TCL_DIR}/bin\",\"${INCR_TCL_LIBRARY_PATH}\",\"${INCR_TK_LIBRARY_PATH}\",\"${OPENGL_gl_LIBRARY_PATH}\"")
    set(Slicer3_FORWARD_PATH_INSTALL
      "\"../${Slicer3_INSTALL_LIB_DIR}\",\"../lib/vtk-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}\",\"../lib/KWWidgets\",\"../lib/InsightToolkit\",\"../lib/Teem-${Teem_VERSION_MAJOR}.${Teem_VERSION_MINOR}\",\"../lib/TclTk/lib\",\"../lib/TclTk/lib/itcl${INCR_TCL_VERSION_DOT}\",\"../lib/TclTk/lib/itk${INCR_TCL_VERSION_DOT}\",\"../lib/FreeSurfer\",\"../lib/IGT\",\"../lib/ITKCommandIO\",\"../lib/LoadableModule\",\"../lib/MGHImageIO\",\"../lib/MRML\",\"../lib/ModuleDescriptionParser\",\"../lib/MRMLIDImageIO\",\"../lib/Qdec\",\"../lib/RemoteIO\",\"../lib/SlicerIO\",\"../lib/tclap\",\"../lib/vtkITK\",\"../lib/vtkTeem\"")
    if(Slicer3_BUILD_MODULES)
      set(Slicer3_FORWARD_PATH_BUILD 
        "${Slicer3_FORWARD_PATH_BUILD},\"${Slicer3_HOME}/${Slicer3_INSTALL_MODULES_BIN_DIR}\"")
    endif(Slicer3_BUILD_MODULES)
    if(Slicer3_BUILD_CLI)
      set(Slicer3_FORWARD_PATH_BUILD 
        "${Slicer3_FORWARD_PATH_BUILD},\"${Slicer3_HOME}/${Slicer3_INSTALL_PLUGINS_BIN_DIR}\"")
    endif(Slicer3_BUILD_CLI)
  endif(WIN32)
  if(Slicer3_BUILD_MODULES)
    set(Slicer3_FORWARD_PATH_INSTALL
      "${Slicer3_FORWARD_PATH_INSTALL},\"../${Slicer3_INSTALL_MODULES_BIN_DIR}\"")
  endif(Slicer3_BUILD_MODULES)
  if(Slicer3_BUILD_CLI)
    set(Slicer3_FORWARD_PATH_INSTALL
      "${Slicer3_FORWARD_PATH_INSTALL},\"../${Slicer3_INSTALL_PLUGINS_BIN_DIR}\"")
  endif(Slicer3_BUILD_CLI)
endif(BUILD_SHARED_LIBS)

# Add main server executables.
set(Slicer3_EXE_LIST Slicer3)

# Add shared link forwarding executables if necessary.
if(Slicer3_NEED_SHARED_FORWARD)
  foreach(slicer_exe ${Slicer3_EXE_LIST})
    set(Slicer3_FORWARD_EXE ${slicer_exe}${Slicer3_EXE_SUFFIX})
    configure_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/Slicer3-forward.c.in
      ${CMAKE_CURRENT_BINARY_DIR}/${slicer_exe}-forward.c
      @ONLY IMMEDIATE)
    add_executable(${slicer_exe} WIN32
      ${CMAKE_CURRENT_BINARY_DIR}/${slicer_exe}-forward.c)
    add_dependencies(${slicer_exe} ${Slicer3_FORWARD_EXE})
    install(TARGETS ${slicer_exe}
      DESTINATION ${Slicer3_INSTALL_BIN_DIR}
      COMPONENT Runtime)
  endforeach(slicer_exe)
endif(Slicer3_NEED_SHARED_FORWARD)

# --------------------------------------------------------------------------
# Sources
#
set(SRC
  Slicer3.cxx
  )

# --------------------------------------------------------------------------
# Find SLICERLIBCURL (slicercurl)
#
find_package(SLICERLIBCURL REQUIRED)
include(${SLICERLIBCURL_USE_FILE})

# --------------------------------------------------------------------------
# Include dirs
#
set(dir_list
  ${Slicer3_SOURCE_DIR}
  ${Slicer3_BINARY_DIR}
  ${Slicer3_Libs_INCLUDE_DIRS}
  ${Slicer3_Base_INCLUDE_DIRS}
  ${NAVITRACK_INC}
  ${IGSTK_INCLUDE_DIRS}
  ${Volumes_SOURCE_DIR}
  ${Volumes_BINARY_DIR}
  ${Volumes_Init_SOURCE_DIR}
  ${Volumes_Init_BINARY_DIR}
  ${GradientAnisotropicDiffusionFilter_SOURCE_DIR}
  ${GradientAnisotropicDiffusionFilter_BINARY_DIR}
  ${GradientAnisotropicDiffusionFilter_Init_SOURCE_DIR}
  ${GradientAnisotropicDiffusionFilter_Init_BINARY_DIR}
  ${SlicerTractographyDisplay_SOURCE_DIR}
  ${SlicerTractographyDisplay_BINARY_DIR}
  ${SlicerTractographyDisplay_Init_SOURCE_DIR}
  ${SlicerTractographyDisplay_Init_BINARY_DIR}
  ${SlicerTractographyFiducialSeeding_SOURCE_DIR}
  ${SlicerTractographyFiducialSeeding_BINARY_DIR}
  ${SlicerTractographyFiducialSeeding_Init_SOURCE_DIR}
  ${SlicerTractographyFiducialSeeding_Init_BINARY_DIR}
  ${EMSegment_SOURCE_DIR}
  ${EMSegment_BINARY_DIR}
  ${EMSegment_Init_SOURCE_DIR}
  ${EMSegment_Init_BINARY_DIR}
  ${RealTimeImaging_SOURCE_DIR}
  ${RealTimeImaging_BINARY_DIR}
  ${RealTimeImaging_Init_SOURCE_DIR}
  ${RealTimeImaging_Init_BINARY_DIR}
  ${MRAblation_SOURCE_DIR}
  ${MRAblation_BINARY_DIR}
  ${MRAblation_Init_SOURCE_DIR}
  ${MRAblation_Init_BINARY_DIR}
  ${LabelStatistics_SOURCE_DIR}       
  ${LabelStatistics_BINARY_DIR}
  ${LabelStatistics_Init_SOURCE_DIR}
  ${LabelStatistics_Init_BINARY_DIR}
  ${WFEngineModule_SOURCE_DIR}
  ${WFEngineModule_BINARY_DIR}
  ${WFEngineModule_Init_SOURCE_DIR}
  ${WFEngineModule_Init_BINARY_DIR}
  ${CommandLineModule_SOURCE_DIR}
  ${CommandLineModule_BINARY_DIR}
  ${CommandLineModule_Init_SOURCE_DIR}
  ${CommandLineModule_Init_BINARY_DIR}
  ${ScriptedModule_SOURCE_DIR}
  ${ScriptedModule_BINARY_DIR}
  ${SlicerDaemon_SOURCE_DIR}
  ${SlicerDaemon_BINARY_DIR}
  ${SlicerDaemon_Init_SOURCE_DIR}
  ${SlicerDaemon_Init_BINARY_DIR}
  )

if(Slicer3_BUILD_MODULES)
  add_definitions(-DSlicer3_BUILD_MODULES)
endif(Slicer3_BUILD_MODULES)

if(Slicer3_BUILD_CLI)
  add_definitions(-DSlicer3_BUILD_CLI)
endif(Slicer3_BUILD_CLI)

if(Slicer3_USE_PYTHON AND PYTHON_INCLUDE_PATH)
  set(dir_list ${dir_list} ${PYTHON_INCLUDE_PATH})
  if(WIN32)
    set(dir_list ${dir_list} ${PYTHON_INCLUDE_PATH}/../PC)
  endif(WIN32)
endif(Slicer3_USE_PYTHON AND PYTHON_INCLUDE_PATH)

include_directories(${dir_list})

# --------------------------------------------------------------------------
# with the WIN32_CONSOLE you can see diagnostic output on in a DOS-style
# cmd window
#
option(Slicer3_BUILD_WIN32_CONSOLE 
  "Build Slicer3 executable as a console app on windows (allows debug output)" 
  OFF
  )

if(Slicer3_BUILD_WIN32_CONSOLE)
  add_executable(Slicer3${Slicer3_EXE_SUFFIX} 
    ${SRC} 
    ${RC_FILENAME}
    )
else(Slicer3_BUILD_WIN32_CONSOLE)
  add_executable(
    Slicer3${Slicer3_EXE_SUFFIX} WIN32 
    ${SRC} 
    ${RC_FILENAME}
    )
endif(Slicer3_BUILD_WIN32_CONSOLE)

# --------------------------------------------------------------------------
# Options
#
if(WFENGINEMODULE)
  set(WFENGINE_LINK_LIB ${WFENGINE_LINK_LIB} WFEngineModule)
else(WFENGINEMODULE)
  add_definitions(-DWFENGINE_DEBUG)
endif(WFENGINEMODULE)

if(LABELSTATISTICS)
  set(LABELSTATISTICS_LINK_LIB LabelStatistics)
else(LABELSTATISTICS)
  add_definitions(-DLABELSTATISTICS_DEBUG)
endif(LABELSTATISTICS)

# --------------------------------------------------------------------------
# Link
# Important: remove RemoteIO when using CMake 2.6. Couldn't be part of 
# Slicer3_LIBRARIES right now because of the Curl lib RemoteIO is using is
# STATIC, but that's fixed in 2.6.
#
target_link_libraries(Slicer3${Slicer3_EXE_SUFFIX}
  ${Slicer3_Libs_LIBRARIES}
  ${Slicer3_Base_LIBRARIES}
  RemoteIO
  ${KWWidgets_LIBRARIES}
#  ${SLICERLIBCURL_LIBRARIES}
  )

if(Slicer3_BUILD_MODULES)
  target_link_libraries(Slicer3${Slicer3_EXE_SUFFIX}
    Volumes
    CommandLineModule
    ScriptedModule
    SlicerDaemon
    SlicerTractographyDisplay
    SlicerTractographyFiducialSeeding
    )
else(Slicer3_BUILD_MODULES)
  # if Slicer3_BUILD_CLI is ON, we still need at least the CommandLineModule
  # so that we can have CLI, without all the other modules
  if(Slicer3_BUILD_CLI)
    target_link_libraries(Slicer3${Slicer3_EXE_SUFFIX}
      CommandLineModule
      )
  endif(Slicer3_BUILD_CLI)
endif(Slicer3_BUILD_MODULES)

if(Slicer3_USE_PYTHON AND PYTHON_LIBRARIES)
  target_link_libraries(Slicer3${Slicer3_EXE_SUFFIX} SlicerBaseGUIPython)
  if(WIN32 AND PYTHON_DEBUG_LIBRARIES)
    target_link_libraries(Slicer3${Slicer3_EXE_SUFFIX}
      debug ${PYTHON_DEBUG_LIBRARIES}
      optimized ${PYTHON_LIBRARIES})
  else(WIN32 AND PYTHON_DEBUG_LIBRARIES)
    target_link_libraries(Slicer3${Slicer3_EXE_SUFFIX} ${PYTHON_LIBRARIES})
  endif(WIN32 AND PYTHON_DEBUG_LIBRARIES)
  if(NOT WIN32)
    # Linux/Unix requires util library, but mac doesn't
    if(APPLE OR UNIX)
      target_link_libraries(Slicer3${Slicer3_EXE_SUFFIX})
    else(APPLE OR UNIX)
      target_link_libraries(Slicer3${Slicer3_EXE_SUFFIX} util)
    endif(APPLE OR UNIX)
  endif(NOT WIN32)
endif(Slicer3_USE_PYTHON AND PYTHON_LIBRARIES)

# --------------------------------------------------------------------------
# Install
#
install(TARGETS Slicer3${Slicer3_EXE_SUFFIX}
  DESTINATION ${Slicer3_INSTALL_BIN_DIR}
  COMPONENT Runtime)

# --------------------------------------------------------------------------
# If needed, copy the Tcl/Tk support files required at run-time 
# to initialize Tcl/Tk. This is only triggered if VTK was built
# against a Tcl/Tk static library.

include("${KWWidgets_CMAKE_DIR}/KWWidgetsTclTkMacros.cmake")
kwwidgets_copy_tcl_tk_support_files("${Slicer3_BINARY_DIR}/lib")
kwwidgets_install_tcl_tk_support_files("/lib")

# --------------------------------------------------------------------------
# Use the command line utilities
#
find_package(GenerateCLP REQUIRED)
if(GenerateCLP_FOUND)
  include(${GenerateCLP_USE_FILE})
endif(GenerateCLP_FOUND)

generateclp(${SRC} Slicer3.xml)

# --------------------------------------------------------------------------
# Testing
#
IF(Slicer3_BUILD_TESTING)
  ADD_SUBDIRECTORY(Testing)
ENDIF(Slicer3_BUILD_TESTING)

=== Applications/SlicerQT/CMakeLists.txt ===
PROJECT(SlicerQT)

# --------------------------------------------------------------------------
# Enable shared link forwarding support if needed.
#
# get_filename_component(TCL_LIBRARY_PATH "${TCL_LIBRARY}" PATH)
# get_filename_component(TCL_DIR "${TCL_LIBRARY_PATH}" PATH)
# get_filename_component(INCR_TCL_LIBRARY_PATH "${INCR_TCL_LIBRARY}" PATH)
# get_filename_component(INCR_TK_LIBRARY_PATH "${INCR_TK_LIBRARY}" PATH)

# Some people use Mesa instead of the default system OpenGL.
# Try to incorporate that in the launcher, but NOT for installation.

# if(NOT WIN32)
#   foreach(dependency ${vtkftgl_LIB_DEPENDS})
#     get_filename_component(dependency_lib "${dependency}" NAME_WE)
#     if(dependency_lib STREQUAL "libGL")
#       get_filename_component(OPENGL_gl_LIBRARY_PATH "${dependency}" PATH)
#     endif(dependency_lib STREQUAL "libGL")
#   endforeach(dependency)
# endif(NOT WIN32)

SET(SlicerQT_EXE_SUFFIX)
SET(SlicerQT_EXE_INSTALL ${Slicer3_INSTALL_BIN_DIR})
IF(BUILD_SHARED_LIBS)
  SET(SlicerQT_NEED_SHARED_FORWARD 1)
  SET(SlicerQT_EXE_SUFFIX -real)
  SET(SlicerQT_EXE_INSTALL ".")
  SET(SlicerQT_FORWARD_DIR_BUILD "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")
  SET(SlicerQT_FORWARD_DIR_INSTALL "${SlicerQT_EXE_INSTALL}")
  if(WIN32)
    #Nota: Removed the following
    #\"${KWWidgets_RUNTIME_DIRS}\" CONFIG_DIR_POST,
    #\"${TCL_DIR}/bin\",
    #\"${INCR_TCL_LIBRARY_PATH}\",
    #\"${INCR_TK_LIBRARY_PATH}\"
    SET(SlicerQT_FORWARD_PATH_BUILD
      "\"${SlicerQT_FORWARD_DIR_BUILD}\" CONFIG_DIR_POST,    \\
       \"${VTK_DIR}/bin\" CONFIG_DIR_POST,                   \\
       \"${ITK_DIR}/bin\" CONFIG_DIR_POST,                   \\
       \"${Teem_DIR}/bin\" CONFIG_DIR_POST")

    #SET(SlicerQT_FORWARD_PATH_INSTALL
    #  "\"../lib/TclTk/bin\",
    #   \"../lib/TclTk/lib/itcl${INCR_TCL_VERSION_DOT}\",
    #   \"../lib/TclTk/lib/itk${INCR_TCL_VERSION_DOT}\"")

    IF(Slicer3_BUILD_QTLOADABLEMODULES)
      SET(SlicerQT_FORWARD_PATH_BUILD
        "${SlicerQT_FORWARD_PATH_BUILD},          \\
         \"${Slicer3_HOME}/${Slicer3_INSTALL_QTLOADABLEMODULES_BIN_DIR}\" CONFIG_DIR_POST")
      SET(SlicerQT_FORWARD_PATH_INSTALL
        "\"../${Slicer3_INSTALL_QTLOADABLEMODULES_BIN_DIR}\"")

      # Since ModuleLogic are in Slicer3_INSTALL_MODULES_BIN_DIR, let's add it
      SET(Slicer3_FORWARD_PATH_BUILD
        "${Slicer3_FORWARD_PATH_BUILD},            \\
        \"${Slicer3_HOME}/${Slicer3_INSTALL_MODULES_BIN_DIR}\" CONFIG_DIR_POST")
    
    ENDIF(Slicer3_BUILD_QTLOADABLEMODULES)
     
    #IF(Slicer3_BUILD_MODULES)
    #  SET(Slicer3_FORWARD_PATH_BUILD
    #    "${Slicer3_FORWARD_PATH_BUILD},\"${Slicer3_HOME}/${Slicer3_INSTALL_MODULES_BIN_DIR}\" CONFIG_DIR_POST")
    #ENDIF(Slicer3_BUILD_MODULES)
    
    IF(Slicer3_BUILD_CLI)
      SET(SlicerQT_FORWARD_PATH_BUILD
        "${SlicerQT_FORWARD_PATH_BUILD},            \\
        \"${Slicer3_HOME}/${Slicer3_INSTALL_PLUGINS_BIN_DIR}\" CONFIG_DIR_POST")
    ENDIF(Slicer3_BUILD_CLI)
    
  ELSE(WIN32)
  
    #Nota: Removed the following
    #\"${KWWidgets_RUNTIME_DIRS}\",
    #\"${TCL_DIR}/bin\",
    #\"${INCR_TCL_LIBRARY_PATH}\",
    #\"${INCR_TK_LIBRARY_PATH}\",
    SET(SlicerQT_FORWARD_PATH_BUILD
      "\"${Slicer3_FORWARD_DIR_BUILD}\",  \\
       \"${VTK_DIR}/bin\",                \\
       \"${ITK_DIR}/bin\",                \\
       \"${Teem_DIR}/bin\",               \\
       \"${OPENGL_gl_LIBRARY_PATH}\"")

    # Nota: Removed the following
    #\"../lib/KWWidgets\",\"../lib/InsightToolkit\",
    #\"../lib/TclTk/lib\",
    #\"../lib/TclTk/lib/itcl${INCR_TCL_VERSION_DOT}\",
    #\"../lib/TclTk/lib/itk${INCR_TCL_VERSION_DOT}\",
    SET(SlicerQT_FORWARD_PATH_INSTALL
      "\"../${Slicer3_INSTALL_LIB_DIR}\",                           \\
       \"../lib/vtk-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}\",    \\
       \"../lib/Teem-${Teem_VERSION_MAJOR}.${Teem_VERSION_MINOR}\", \\
       \"../lib/FreeSurfer\",                                       \\
       \"../lib/IGT\",                                              \\
       \"../lib/ITKCommandIO\",                                     \\
       \"../lib/LoadableModule\",                                   \\
       \"../lib/MGHImageIO\",                                       \\
       \"../lib/MRML\",                                             \\
       \"../lib/MRMLCLI\",                                          \\
       \"../lib/ModuleDescriptionParser\",                          \\
       \"../lib/MRMLIDImageIO\",                                    \\
       \"../lib/Qdec\",                                             \\
       \"../lib/RemoteIO\",                                         \\
       \"../lib/SlicerIO\",                                         \\
       \"../lib/tclap\",                                            \\
       \"../lib/vtkITK\",                                           \\
       \"../lib/vtkTeem\"")

    IF(Slicer3_BUILD_QTLOADABLEMODULES)
      SET(SlicerQT_FORWARD_PATH_BUILD
        "${SlicerQT_FORWARD_PATH_BUILD},                  \\
         \"${Slicer3_HOME}/${Slicer3_INSTALL_QTLOADABLEMODULES_BIN_DIR}\"")
      SET(SlicerQT_FORWARD_PATH_INSTALL
        "${SlicerQT_FORWARD_PATH_INSTALL},         \\
        \"../${Slicer3_INSTALL_QTLOADABLEMODULES_BIN_DIR}\"")

      # Since ModuleLogic are in Slicer3_INSTALL_MODULES_BIN_DIR, let's add it
      SET(Slicer3_FORWARD_PATH_BUILD
        "${Slicer3_FORWARD_PATH_BUILD},             \\
        \"${Slicer3_HOME}/${Slicer3_INSTALL_MODULES_BIN_DIR}\"")
        
    ENDIF(Slicer3_BUILD_QTLOADABLEMODULES)
    
    #IF(Slicer3_BUILD_MODULES)
    #  SET(Slicer3_FORWARD_PATH_BUILD
    #    "${Slicer3_FORWARD_PATH_BUILD},\"${Slicer3_HOME}/${Slicer3_INSTALL_MODULES_BIN_DIR}\"")
    #ENDIF(Slicer3_BUILD_MODULES)
    
    IF(Slicer3_BUILD_CLI)
      SET(SlicerQT_FORWARD_PATH_BUILD
        "${SlicerQT_FORWARD_PATH_BUILD},         \\
         \"${Slicer3_HOME}/${Slicer3_INSTALL_PLUGINS_BIN_DIR}\"")
    ENDIF(Slicer3_BUILD_CLI)
  ENDIF(WIN32)

#   IF(Slicer3_BUILD_MODULES)
#     SET(Slicer3_FORWARD_PATH_INSTALL
#       "${Slicer3_FORWARD_PATH_INSTALL},\"../${Slicer3_INSTALL_MODULES_BIN_DIR}\"")
#   ENDIF(Slicer3_BUILD_MODULES)
  
  IF(Slicer3_BUILD_CLI)
    SET(SlicerQT_FORWARD_PATH_INSTALL
      "${SlicerQT_FORWARD_PATH_INSTALL},\"../${Slicer3_INSTALL_PLUGINS_BIN_DIR}\"")
  ENDIF(Slicer3_BUILD_CLI)
  
ENDIF(BUILD_SHARED_LIBS)

# --------------------------------------------------------------------------

#MESSAGE(STATUS SlicerQT_FORWARD_DIR_BUILD:${SlicerQT_FORWARD_DIR_BUILD})
#MESSAGE(STATUS SlicerQT_FORWARD_PATH_BUILD:${SlicerQT_FORWARD_PATH_BUILD})
#MESSAGE(STATUS SlicerQT_FORWARD_PATH_INSTALL:${SlicerQT_FORWARD_PATH_INSTALL})
#MESSAGE(STATUS SlicerQT_FORWARD_DIR_BUILD:${SlicerQT_FORWARD_DIR_BUILD})
#MESSAGE(STATUS SlicerQT_FORWARD_DIR_INSTALL:${SlicerQT_FORWARD_DIR_INSTALL})

# Add main server executables.
SET(SlicerQT_EXE_LIST SlicerQT)

# Add shared link forwarding executables if necessary.
IF(SlicerQT_NEED_SHARED_FORWARD)
  FOREACH(slicer_exe ${SlicerQT_EXE_LIST})
    SET(SlicerQT_FORWARD_EXE ${slicer_exe}${SlicerQT_EXE_SUFFIX})
    CONFIGURE_FILE(
      ${CMAKE_CURRENT_SOURCE_DIR}/SlicerQT-forward.c.in
      ${CMAKE_CURRENT_BINARY_DIR}/${slicer_exe}-forward.c
      @ONLY IMMEDIATE)
    ADD_EXECUTABLE(${slicer_exe} WIN32
      ${CMAKE_CURRENT_BINARY_DIR}/${slicer_exe}-forward.c)
    ADD_DEPENDENCIES(${slicer_exe} ${SlicerQT_FORWARD_EXE})
    INSTALL(TARGETS ${slicer_exe}
      DESTINATION ${Slicer3_INSTALL_BIN_DIR}
      COMPONENT Runtime)
  ENDFOREACH(slicer_exe)
ENDIF(SlicerQT_NEED_SHARED_FORWARD)

# --------------------------------------------------------------------------
# Sources
#
SET(SlicerQT_SRCS
  qSlicerMainWindow.h
  qSlicerMainWindow.cxx
  qSlicerMainWindowCore.h
  qSlicerMainWindowCore.cxx
  )

SET(SlicerQT_MOC_SRCS
  qSlicerMainWindow.h
  qSlicerMainWindowCore.h
  qSlicerMainWindowCore_p.h
  )
  
SET(SlicerQT_UI_SRCS
  Resources/UI/qSlicerMainWindow.ui
  )

# Resources
SET(qt_module_resources
  Resources/SlicerQT.qrc
  ${qSlicerBaseQTGUI_SOURCE_DIR}/Resources/qSlicerBaseQTGUI.qrc
  ${qSlicerBaseQTCoreModules_SOURCE_DIR}/Resources/qSlicerBaseQTCoreModules.qrc
)
#SET(SlicerQT_RC_FILE Resources/SlicerQT.rc)


QT4_WRAP_CPP(SlicerQT_SRCS ${SlicerQT_MOC_SRCS})
QT4_WRAP_UI(SlicerQT_UI_CXX ${SlicerQT_UI_SRCS})
QT4_ADD_RESOURCES(SlicerQT_QRC_SRCS ${qt_module_resources})

# --------------------------------------------------------------------------
# Find SLICERLIBCURL (slicercurl)
#
# find_package(SLICERLIBCURL REQUIRED)
# include(${SLICERLIBCURL_USE_FILE})

# --------------------------------------------------------------------------
# Include dirs
#
set(include_dirs
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  #${Slicer3_Libs_INCLUDE_DIRS}
  ${Slicer3_Base_INCLUDE_DIRS}
  #${NAVITRACK_INC}
  #${IGSTK_INCLUDE_DIRS}
#   ${Volumes_SOURCE_DIR}
#   ${Volumes_BINARY_DIR}
#   ${Volumes_Init_SOURCE_DIR}
#   ${Volumes_Init_BINARY_DIR}
#   ${GradientAnisotropicDiffusionFilter_SOURCE_DIR}
#   ${GradientAnisotropicDiffusionFilter_BINARY_DIR}
#   ${GradientAnisotropicDiffusionFilter_Init_SOURCE_DIR}
#   ${GradientAnisotropicDiffusionFilter_Init_BINARY_DIR}
#   ${SlicerTractographyDisplay_SOURCE_DIR}
#   ${SlicerTractographyDisplay_BINARY_DIR}
#   ${SlicerTractographyDisplay_Init_SOURCE_DIR}
#   ${SlicerTractographyDisplay_Init_BINARY_DIR}
#   ${SlicerTractographyFiducialSeeding_SOURCE_DIR}
#   ${SlicerTractographyFiducialSeeding_BINARY_DIR}
#   ${SlicerTractographyFiducialSeeding_Init_SOURCE_DIR}
#   ${SlicerTractographyFiducialSeeding_Init_BINARY_DIR}
#   ${EMSegment_SOURCE_DIR}
#   ${EMSegment_BINARY_DIR}
#   ${EMSegment_Init_SOURCE_DIR}
#   ${EMSegment_Init_BINARY_DIR}
#   ${RealTimeImaging_SOURCE_DIR}
#   ${RealTimeImaging_BINARY_DIR}
#   ${RealTimeImaging_Init_SOURCE_DIR}
#   ${RealTimeImaging_Init_BINARY_DIR}
#   ${MRAblation_SOURCE_DIR}
#   ${MRAblation_BINARY_DIR}
#   ${MRAblation_Init_SOURCE_DIR}
#   ${MRAblation_Init_BINARY_DIR}
#   ${LabelStatistics_SOURCE_DIR}       
#   ${LabelStatistics_BINARY_DIR}
#   ${LabelStatistics_Init_SOURCE_DIR}
#   ${LabelStatistics_Init_BINARY_DIR}
#   ${WFEngineModule_SOURCE_DIR}
#   ${WFEngineModule_BINARY_DIR}
#   ${WFEngineModule_Init_SOURCE_DIR}
#   ${WFEngineModule_Init_BINARY_DIR}
#   ${CommandLineModule_SOURCE_DIR}
#   ${CommandLineModule_BINARY_DIR}
#   ${CommandLineModule_Init_SOURCE_DIR}
#   ${CommandLineModule_Init_BINARY_DIR}
#   ${ScriptedModule_SOURCE_DIR}
#   ${ScriptedModule_BINARY_DIR}
#   ${SlicerDaemon_SOURCE_DIR}
#   ${SlicerDaemon_BINARY_DIR}
#   ${SlicerDaemon_Init_SOURCE_DIR}
#   ${SlicerDaemon_Init_BINARY_DIR}
  )

# if(Slicer3_BUILD_MODULES)
#   add_definitions(-DSlicer3_BUILD_MODULES)
# endif(Slicer3_BUILD_MODULES)
# 
# if(Slicer3_BUILD_CLI)
#   add_definitions(-DSlicer3_BUILD_CLI)
# endif(Slicer3_BUILD_CLI)

# if(Slicer3_USE_PYTHON AND PYTHON_INCLUDE_PATH)
#   set(include_dirs ${include_dirs} ${PYTHON_INCLUDE_PATH})
#   if(WIN32)
#     set(include_dirs ${include_dirs} ${PYTHON_INCLUDE_PATH}/../PC)
#   endif(WIN32)
# endif(Slicer3_USE_PYTHON AND PYTHON_INCLUDE_PATH)

INCLUDE_DIRECTORIES(${include_dirs})

# --------------------------------------------------------------------------
# with the WIN32_CONSOLE you can see diagnostic output on in a DOS-style
# cmd window
#
# option(Slicer3_BUILD_WIN32_CONSOLE 
#   "Build Slicer3 executable as a console app on windows (allows debug output)" 
#   OFF
#   )
# 
# if(Slicer3_BUILD_WIN32_CONSOLE)
#   add_executable(Slicer3${Slicer3_EXE_SUFFIX} 
#     ${SRC} 
#     ${RC_FILENAME}
#     )
# else(Slicer3_BUILD_WIN32_CONSOLE)
#   add_executable(
#     Slicer3${Slicer3_EXE_SUFFIX} WIN32 
#     ${SRC} 
#     ${RC_FILENAME}
#     )
# endif(Slicer3_BUILD_WIN32_CONSOLE)

# --------------------------------------------------------------------------
# Options
#
# if(WFENGINEMODULE)
#   set(WFENGINE_LINK_LIB ${WFENGINE_LINK_LIB} WFEngineModule)
# else(WFENGINEMODULE)
#   add_definitions(-DWFENGINE_DEBUG)

=== Base/CLI/CMakeLists.txt ===
PROJECT(SlicerBaseCLI)

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)
MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY)


# --------------------------------------------------------------------------
# Include dirs

SET(include_dirs
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${ModuleDescriptionParser_BINARY_DIR}
  ${ModuleDescriptionParser_SOURCE_DIR}
  )

INCLUDE_DIRECTORIES(${include_dirs})

slicer3_get_persistent_property(Slicer3_Base_INCLUDE_DIRS tmp)
slicer3_set_persistent_property(Slicer3_Base_INCLUDE_DIRS ${tmp} ${include_dirs})

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/vtkSlicerBaseCLIConfigure.h.in 
  ${CMAKE_CURRENT_BINARY_DIR}/vtkSlicerBaseCLIConfigure.h
  )

INSTALL(FILES 
  itkPluginFilterWatcher.h 
  itkPluginUtilities.h 
  vtkPluginFilterWatcher.h 
  vtkSlicerBaseCLIWin32Header.h
  ${CMAKE_CURRENT_BINARY_DIR}/vtkSlicerBaseCLIConfigure.h
  DESTINATION ${Slicer3_INSTALL_INCLUDE_DIR}/${PROJECT_NAME} COMPONENT Development
  )

# --------------------------------------------------------------------------
# Sources

# Single library target. Down the road, we may want to have one library that
# only depends on ITK and a second library that only depends on VTK

SET(SlicerBaseCLI_SRCS
  vtkPluginFilterWatcher.cxx
  )

# --------------------------------------------------------------------------
# Build and install the library

SET(lib_name "SlicerBaseCLI")

ADD_LIBRARY(${lib_name} 
  ${SlicerBaseCLI_SRCS}
  )
TARGET_LINK_LIBRARIES(${lib_name} 
  vtkCommon 
  ModuleDescriptionParser
)

slicer3_get_persistent_property(Slicer3_Base_LIBRARIES tmp)
slicer3_set_persistent_property(Slicer3_Base_LIBRARIES ${tmp} SlicerBaseCLI)

# Apply user-defined properties to the library target.
IF(Slicer3_LIBRARY_PROPERTIES)
  SET_TARGET_PROPERTIES(${lib_name} PROPERTIES ${Slicer3_LIBRARY_PROPERTIES})
ENDIF(Slicer3_LIBRARY_PROPERTIES)

INSTALL(TARGETS ${lib_name}
  RUNTIME DESTINATION ${Slicer3_INSTALL_BIN_DIR} COMPONENT RuntimeLibraries 
  LIBRARY DESTINATION ${Slicer3_INSTALL_LIB_DIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${Slicer3_INSTALL_LIB_DIR} COMPONENT Development
  )

=== debian/changelog ===
slicer (3.6.3~svn16592-1) unstable; urgency=low

  * New upstream snapshot
  * Switched to CDBS
  * Include <stddef.h> to ensure ptrdiff_t is defined. (Closes: #625103)
  * Set -DBUILD_BRAINSTOOLS:BOOL=ON
  * Removed modules under development
  * Changed menu section to Education;Science;MedicalSoftware;
  * Bump compat level to 8
  * Bump Standards-Version: 3.9.2

 -- Dominique Belhachemi <domibel@debian.org>  Mon, 09 May 2011 21:02:12 -0400

=== debian/control ===
Source: slicer
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Dominique Belhachemi <domibel@debian.org>
Build-Depends: debhelper (>= 8), quilt, cmake, tcl-dev, tk-dev, libfftw3-dev,
 libinsighttoolkit3-dev (>= 3.20.0-10) , libkwwidgets1-dev (>=1.0.0~cvs20100930), tcl-vtk (>= 5.6),
 libcurl4-openssl-dev, libvtk5-dev (>= 5.6.1-5), libteem1-dev, libopenigtlink1-dev,
 libbz2-dev, libtclap-dev, libgdcm2-dev, python-dev, python-vtk (>= 5.6), subversion,
 cdbs
Build-Depends-Indep: doxygen, graphviz
Build-Conflicts: libqt3-mt-dev
Standards-Version: 3.9.2
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/slicer/trunk/?rev=0&sc=0
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/slicer/trunk/
Section: graphics
Homepage: http://www.slicer.org/


Package: slicer
Architecture: any
Depends: libslicer3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
 slicer-data (= ${source:Version}), itcl3, iwidgets4, tcllib, tcl8.5-kwwidgets , python-numpy
Description: software package for visualization and image analysis - main application
 Slicer is an application for computer scientists and clinical researchers. The
 platform provides functionality for segmentation, registration and
 three-dimensional visualization of multi-modal image data, as well as advanced
 image analysis algorithms for diffusion tensor imaging, functional magnetic
 resonance imaging and image-guided therapy. Standard image file formats are
 supported, and the  application integrates interface capabilities to biomedical
 research software and image informatics frameworks. 
 .
 3D Slicer main application.


Package: libslicer3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends} 
Description: software package for visualization and image analysis - runtime
 Slicer is an application for computer scientists and clinical researchers. The
 platform provides functionality for segmentation, registration and
 three-dimensional visualization of multi-modal image data, as well as advanced
 image analysis algorithms for diffusion tensor imaging, functional magnetic
 resonance imaging and image-guided therapy. Standard image file formats are
 supported, and the  application integrates interface capabilities to biomedical
 research software and image informatics frameworks.
 .
 3D Slicer libraries.


Package: libslicer3-dev
Section: libdevel
Architecture: any
Depends: libslicer3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends} 
Description: software package for visualization and image analysis - development
 Slicer is an application for computer scientists and clinical researchers. The
 platform provides functionality for segmentation, registration and
 three-dimensional visualization of multi-modal image data, as well as advanced
 image analysis algorithms for diffusion tensor imaging, functional magnetic
 resonance imaging and image-guided therapy. Standard image file formats are
 supported, and the  application integrates interface capabilities to biomedical
 research software and image informatics frameworks.
 .
 3D Slicer development files.


Package: slicer-data
Section: doc
Architecture: all
Depends: ${misc:Depends}, tk8.5 | wish
Description: software package for visualization and image analysis - share
 Slicer is an application for computer scientists and clinical researchers. The 
 platform provides functionality for segmentation, registration and
 three-dimensional visualization of multi-modal image data, as well as advanced
 image analysis algorithms for diffusion tensor imaging, functional magnetic
 resonance imaging and image-guided therapy. Standard image file formats are
 supported, and the  application integrates interface capabilities to biomedical
 research software and image informatics frameworks.
 .
 3D Slicer data files.

=== debian/rules ===
#!/usr/bin/make -f

# Set this value to 0/1 to turn off/on verbose mode.
export DH_VERBOSE=0

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/patchsys-quilt.mk

DEB_BUILD_PARALLEL := true

DEB_CMAKE_EXTRA_FLAGS = \
              -DCMAKE_INSTALL_PREFIX:PATH=/usr \
              -DCMAKE_BUILD_TYPE:STRING=Release \
              -DCMAKE_VERBOSE_MAKEFILE:BOOL=$(DH_VERBOSE) \
              -DVOLUMERENDERINGMODULE:BOOL=ON \
              -DCMAKE_SKIP_RPATH:BOOL=OFF \
              -DBUILD_TESTING:BOOL=ON \
              -DCMAKE_SHARED_LINKER_FLAGS:STRING="-Wl,--as-needed" \
              -DCMAKE_EXE_LINKER_FLAGS:STRING="-Wl,--as-needed" \
              -DSlicer3_USE_IGSTK:BOOL=OFF \
              -DSlicer3_USE_OPENIGTLINK:BOOL=ON \
              -DSlicer3_USE_MIDAS:BOOL=ON \
              -DSlicer3_WITH_LIBRARY_VERSION:BOOL=ON \
              -DBUILD_BRAINSTOOLS:BOOL=ON \
              -DSlicer3_USE_PYTHON:BOOL=ON

DEB_DH_SHLIBDEPS_ARGS_slicer := -l$(CURDIR)/debian/tmp/usr/lib:$(CURDIR)/debian/tmp/usr/lib/Slicer3:$(CURDIR)/debian/tmp/usr/lib/Slicer3/Modules:$(CURDIR)/debian/tmp/usr/lib/Slicer3/Plugins
DEB_DH_SHLIBDEPS_ARGS_libslicer3 := -l$(CURDIR)/debian/tmp/usr/lib:$(CURDIR)/debian/tmp/usr/lib/Slicer3:$(CURDIR)/debian/tmp/usr/lib/Slicer3/Modules:$(CURDIR)/debian/tmp/usr/lib/Slicer3/Plugins

build/slicer::
	mkdir -p $(DEB_BUILDDIR)/lib/Slicer3
	echo "build `uname -m`\nbuildDate `date +"%Y-%m-%d"`\nsvnurl http://svn.slicer.org/Slicer3/trunk\nsvnrevision 16592" > $(DEB_BUILDDIR)/lib/Slicer3/Slicer3Version.txt

install/slicer::
	# remove empty directories
	rmdir    $(CURDIR)/debian/tmp/usr/share/Slicer3/Modules/ModelIntoLabelVolume/Testing/TestData/
	rmdir    $(CURDIR)/debian/tmp/usr/share/Slicer3/Modules/ModelIntoLabelVolume/Testing/
	rmdir    $(CURDIR)/debian/tmp/usr/share/Slicer3/Modules/ModelIntoLabelVolume/

	chmod +x $(CURDIR)/debian/tmp/usr/lib/Slicer3/Modules/SlicerDaemon/Tcl/slicerget.tcl
	chmod +x $(CURDIR)/debian/tmp/usr/lib/Slicer3/Modules/SlicerDaemon/Tcl/slicerput.tcl
	chmod +x $(CURDIR)/debian/tmp/usr/lib/Slicer3/Modules/SlicerDaemon/Tcl/tracker/tracker.tcl
	chmod +x $(CURDIR)/debian/tmp/usr/lib/Slicer3/SlicerBaseGUI/Tcl/ExternalProgress.tcl
	chmod +x $(CURDIR)/debian/tmp/usr/lib/Slicer3/launch.tcl
	chmod +x $(CURDIR)/debian/tmp/usr/share/FreeSurfer/Testing/fips2mrml.tcl
#	chmod +x $(CURDIR)/debian/tmp/usr/share/Slicer3/Modules/ChangeTracker/Simulation/create_artificial_growth_deformation.sh
	chmod +x $(CURDIR)/debian/tmp/usr/share/Slicer3/Modules/QueryAtlas/Tcl/QueryAtlasFips2Mrml.tcl
	chmod -x $(CURDIR)/Utilities/Launcher/3DSlicerLogoICOimages/3DSlicerLogo-DesktopIcon-48x48x256.png

	dh_install --sourcedir=$(CURDIR)/debian/tmp --list-missing

get-orig-source:
	/bin/sh $(CURDIR)/debian/get-orig-source
